'use strict';

const express = require('express');
const app = express()
const expressWs = require('express-ws')(app);
const mongoose = require('mongoose');
const hashModel = require('./mongo/hash');
const { Slave } = require('./entity/slave');
const { initSwarmManager, checkInactive } = require('./utils/swarm');
const { slaves } = require('../entity/slave');

const mongoHost = 'URL_MONGO' in process.env ? process.env.URL_MONGO : "mongodb://mongo:27017";
mongoose.connect(mongoHost + '/docker-swarm');

const PORT = 3001



let slaveCount = 0;


/**
 * Insert le hash et la solution dans la base mongo pour les retrouvé plus rapidement 
 * @param hash: le hash
 * @param solution: la solution
 */
function insertHash(hash, solution) {
    let hashMongoose = new hashModel({
        hash: hash,
        solution: solution
    });
    hashMongoose.save(function (err, hashDb) {
        if (err) {
            console.error(err);
        } else {
            console.log("New hash : " + hash + " - " + msg);
        }
    });
}



// Protocol HTML
app.get('/', (req, res) => {
    res.send('Serveur is Up!')
})


initSwarmManager()
const server = app.listen(PORT, () => {
    console.log(`App listening at http://localhost:${PORT}`);
});

process.on('SIGINT', () => {
    server.close(() => {
        console.log('\nServer closed - All Slaves killed');
        process.exit();
    });
});